import kareltherobot.*;

public class Adder extends Finder  // Always create on 1st Street, facing North.
{	
	private Carrier carry = new Carrier(1,1, East, infinity);
	private Checker check = new Checker(1,1, East, 0);

	public Adder(int street, int avenue, Direction direction, int beepers)
	{	super(street, avenue, direction, beepers);
	}
	
	public void gatherHelpers() // Adder class
	{	carry.moveToRobot();
		carry.turnLeft();
		check.moveToRobot();
		check.turnLeft();
	}
	
	public void addAll()
	{	while( ! onSecondAve() )
		{	addColumn();
			slideLeft();
		}
		addColumn();
	}
	
	
	public void addColumn() // Facing north on 1st Street. 
	{	move();
		while(nextToABeeper())
		{	pickBeeper();
			if ( ! nextToABeeper() )
			{	move();
			}
		}
		turnAround();
		while( frontIsClear() )
		{	move();
		}
		turnAround();
		while ( anyBeepersInBeeperBag() )
		{	putBeeper();
		}
		// Compute the quotient and the remainder. 
		while( check.enoughToCarry() )
		{	carry.carryOne();
		}
	}
	
	public void slideLeft()
	{	turnLeft();
		move();
		turnRight();
		carry.turnLeft();
		carry.move();
		carry.turnRight();
		check.turnLeft();
		check.move();
		check.turnRight();
	}
	
	public boolean onSecondAve()	
	//precondition facing North and Not on 1st. Ave.
	{	turnLeft();
		move();
		if (frontIsClear())
		{	turnAround();
			move();
			turnLeft();
			return false;
		}
		turnAround();
		move();
		turnLeft();
		return true;
	}


}

   
