/*
 * Created on Jun 14, 2004
 *
 */
import kareltherobot.*;

import java.awt.Color;

/**
 * @author jbergin
 *
 */
public class HighJumper extends UrRobot
{

    public HighJumper(int street, int avenue, Direction direction, int beepers, Color badge)
    {
        super(street, avenue, direction, beepers, badge);
    }

    public HighJumper(int street, int avenue, Direction direction, int beepers)
    {
        super(street, avenue, direction, beepers);
    }
    
    public void setStrategy(JumpStrategy strategy)
    {
        this.strategy = strategy;
    }
    
    public void fetch()
    {
        strategy.jump(this);
    }
    
    private JumpStrategy strategy = JumpStrategy.SimplePick;
}
