/*
 * Created on Oct 13, 2003
 *
 */
import kareltherobot.*;

import java.awt.Color;

/** A Turing Machine robot to write a blank in the first cell to the right
 * of the origin (inclusive) that originally has a 1. 
 * @author jbergin
 *
 */
public class PickOneTM extends TuringMachine
{
	public PickOneTM()
	{
		super();
	}

	public PickOneTM(Color badge)
	{
		super(badge);
	}

	public void state1()
	{       
		if(nextToABeeper())
		{       
			putBlank();
			finalState();
		}
		else
		{	moveRight();
			state1();
		}


	}
	
	public static void main(String [] args)
	{	World.placeBeepers(1,3, 1);
		World.setVisible(true);
		PickOneTM karel = new PickOneTM();
	}
}