import kareltherobot.*;

import java.util.Enumeration;

public class Spy extends UrRobot
{
	public Spy(int street, int avenue, Direction direction, 
	     int beepers, Strategy initialStrategy)
	{
		super(street, avenue, direction, beepers);
		myStrategy = initialStrategy;
	}

	public void getNextClue()
	{
	 // precondition. Robot must be on a corner with another robot.
		Enumeration neighbors = neighbors();
		Accomplice accomplice = 
			(Accomplice)neighbors.nextElement();
		myStrategy = accomplice.requestStrategy();
	}

	public void followStrategy()
	{
		myStrategy.doIt(this); // leaves you at the next accomplice
	}
	
	private Strategy myStrategy = null;
}
