import kareltherobot.*;

class TwoBlockStrategy implements Strategy
{
	public void doIt(UrRobot who)
	{
		// to be done
	}
}

class ThreeBlockStrategy implements Strategy
{
	public void doIt(UrRobot who)
	{
		// to be done
	}
}

public class BlockWalker extends UrRobot
{
	public BlockWalker(int street, int avenue, Direction direction, int beepers)
	{
		super(street, avenue, direction, beepers);
	}

	public void walkASide()
	{
		myStrategy.doIt(this);
		swapStrategies();
	}

	private void swapStrategies()
	{
		Strategy tempStrategy = myStrategy;
		myStrategy = otherStrategy;
		otherStrategy = tempStrategy;
	}

	private Strategy myStrategy = new ThreeBlockStrategy(); // to be built
	private Strategy otherStrategy = new TwoBlockStrategy(); /// to be built

}
