import kareltherobot.*;

public class Guard extends Robot
{	
	public Guard(int street, int avenue, Direction direction, int beepers)
	{	super(street, avenue, direction, beepers);
	}
	
	
	public void walkPerimeter() // Robot begins at a corner of the field
	{	for(int j = 0; j < 4; j++)
		{	followEdge();
			turnLeft();
		}
	}
	
	private void turnAround() 
	{	turnLeft();
		turnLeft();
	}
	
	private void backUp() 
	{	turnAround();
		move();
		turnAround();
	}

	private void followEdge() //Robot starts on a corner with a beeper
	{	while (nextToABeeper())
		{	move();
		}
		backUp();
	}
	
	private void faceSouth()
	{	while (! facingSouth())
		{	turnLeft();
		}
	}
	
	public void moveToSouthEastCorner()
	{	faceSouth();
		followEdge(); // Now at south edge of field
		turnLeft();
		followEdge();
		turnLeft(); // Now at south-east corner of field facing North
	}
	
	public boolean nextToABeeper_and_frontIsClear()
	{	if( nextToABeeper() )
		{	return frontIsClear();
		}
		return false;
	}
	
//	public void followEdge() //Robot starts on a corner with a beeper
//	{	while(nextToABeeper())	
//		{	if(frontIsClear())
//			{	move();
//			}
//			else
//			{	pickBeeper();
//			}
//		}
//		if(frontIsBlocked())
//		{	putBeeper();
//		}
//		else
//		{	backUp();
//		}
//	}


}
