import kareltherobot.*;

public class Harvester extends UrRobot 
{
	public Harvester(int street, int avenue, Direction direction, int beepers)
	{	super(street, avenue, direction, beepers);
	}

	public void harvestTwoRows() 
	{	// Before executing this, the robot should be facing East,
		//	on the first beeper of the current row.  
		harvestOneRow();
		goToNextRow();
		harvestOneRow();
	}

	public void positionForNextHarvest() 
	{	// Before executing this, the robot should be facing West,
		//   on the last corner of the current row.
		turnRight();
		move();
		turnRight();
	}

	private void turnRight() 
	{	turnLeft();
		turnLeft();
		turnLeft();
	}	

	private void  harvestOneRow() 
	{	harvestCorner();
		move();
		harvestCorner();
		move();
		harvestCorner();
		move();
		harvestCorner();
		move();
		harvestCorner();
	}

	private void  harvestCorner()
	{	pickBeeper();
	}	
	
	private void  goToNextRow() 
	{	// Before executing this, the robot should be facing East,
		//   on the last corner of the current row. 
		turnLeft();
		move();
		turnLeft();
	}	


	public static void main(String [] args) 
	{	Harvester mark = new Harvester(2, 2, East, 0);
		mark.move();
		mark.harvestTwoRows();
		mark.positionForNextHarvest();
		mark.harvestTwoRows();
		mark.positionForNextHarvest();
		mark.harvestTwoRows();
		mark.move();
		mark.turnOff();
	}
}
