//  Copyright 1999, Joseph Bergin. All rights reserved.

package kareltherobot;

import java.awt.Color;

public class AugmentedRobot extends Robot
{	public AugmentedRobot(int street, int avenue, Direction direction, int beepers)
	{	super(street, avenue, direction, beepers);
	}
	
	public AugmentedRobot(int street, int avenue, Direction direction, int beepers, Color badge)
	{	super(street, avenue, direction, beepers, badge);
	}
	
	
	public void  turnAround ()
	{	turnLeft();
		turnLeft();
	}

	public void  turnRight ()
	{	turnLeft();
		turnLeft();
		turnLeft();
	}

	public void  backUp ()
	{	turnAround();
		move();
		turnAround();
	}

	public boolean  leftIsClear()
	{	turnLeft();
		if( frontIsClear() )
		{	turnRight();
			return true;
		}
		else
		{	turnRight();
			return false;
		}
	}

	public boolean  rightIsClear()
	{	turnRight();
		if( frontIsClear() )
		{	turnLeft();
			return true;
		}
		else
		{	turnLeft();
			return false;
		}
	}

	public void  faceNorth()
	{	while( ! facingNorth() )
		{	turnLeft(); 
		}
	}

	public void  faceEast()
	{	while( ! facingEast() )
		{	turnLeft(); 
		}
	}

	public void  faceSouth()
	{	while( ! facingSouth() )
		{	turnLeft(); 
		}
	}

	public void  faceWest()
	{	while( ! facingWest() )
		{	turnLeft(); 
		}
	}

}
